
import java.awt.Color;


PImage textV,bild, bildV, BitVerteilung, bit1Rot, bit1Gruen, bit1Blau;
PImage bit1Farbe, bit1Saettigung, bit1Helligkeit, bildAnzeigen;
int N,M, bit1,bit2;
int anzahlNull, anzahlEins, anzahlDurchschnitt, anzahlZuwenig;
int x,y; 
color farbe1,farbe2;
int helligkeit, saettigung, farbwert;
int rot,gruen,blau;


void settings(){
   bildAnzeigen = loadImage("data/info.png");//Info-Bild
   bild = loadImage("data/bild.png");
   N = bild.width;//Bildbreite
   M = bild.height;//Bildhöhe
   size(N,M);  
   anzahlNull = anzahlEins = 0;
   
}

void setup() { 
 //damit keyPressed funktioniert
}

void draw () { 
 
  image(bildAnzeigen,0,0,N,N);
}

void keyPressed(){  
  //Anzahl weiße/schwarze Punkte in Bild und Text zählen
   if (key == 'a'){   
    BitVerteilung = loadImage("data/BitVerteilung.png");
    for (int j = 0; j < M; j++) {
      for (int i = 0; i < N; i++) { 
        farbe1 = BitVerteilung.get(i,j);
        bit1 =farbe1 >> 32 & 1;
        if(bit1 == 0) anzahlNull++;
         else anzahlEins++;
      }
    }
    println("Text: "+anzahlNull,anzahlEins); 
    anzahlNull = anzahlEins = 0;
     for (int j = 0; j < M; j++) {
      for (int i = 0; i < N; i++) { 
        farbe1 = bild.get(i,j);
        bit1 =farbe1 >> 32 & 1;
        if(bit1 == 0) anzahlNull++;
         else anzahlEins++;
      }
    }
     println("Bild: "+anzahlNull,anzahlEins); 
  }
  
  
  if (key == '1'){   //RGB-Mode und HSB-Mode für Bit 1
     bitAuslesen(1);
  }
  
  if (key == '2'){  //RGB-Mode und HSB-Mode für Bit 2...
     bitAuslesen(2);
  }
  
  if (key == '3'){
     bitAuslesen(4);
  }
  
  if (key == '4'){
     bitAuslesen(8);
  }
  
  if (key == '5'){
     bitAuslesen(16);
  }
  
  if (key == '6'){
     bitAuslesen(32);
  }
  
   if (key == '7'){
     bitAuslesen(64);
  }
  
  if (key ==  '8'){
     bitAuslesen(128);
  }
  ////////////////////////////////////////////
  if (key == '0'){  //Alle 1-Bits von blau auf 1 setzen
    alleBlauBitsEins();
  }
  
}
/////////////////////////////////////////////////////////////////////////////
//Alle Bits in den Kanälen an der Position "bitPosition" auslesen
void bitAuslesen(int bitPosition){
  //RGB-Modus 
    colorMode(RGB);
    bildAnzeigen = bild;
    bild = loadImage("data/bild.png");//Kontrolle der lowBit-Verteilung ursprünglich
    bit1Rot = loadImage("data/leer.png");
    bit1Gruen = loadImage("data/leer.png");
    bit1Blau = loadImage("data/leer.png");
    for (int j = 0; j < M; j++) {
      for (int i = 0; i < N; i++) { 
        farbe1 = bild.get(i,j); //println(red(farbe1));
        rot =  ((farbe1 >> 16) & 0xFF) & bitPosition; //Rot-Kanal
        gruen =  ((farbe1 >> 8) & 0xFF) & bitPosition;
        blau =  ((farbe1 & 0xFF) & 0xFF) & bitPosition;
        
        if(rot == 0){
          bit1Rot.set(i,j,color(0));
        }else if(rot == 1){
          bit1Rot.set(i,j,color(255));
        }
        
         if(gruen == 0){
          bit1Gruen.set(i,j,color(0));
        }else if(gruen == 1){
          bit1Gruen.set(i,j,color(255));
        }
        
         if(blau == 0){
          bit1Blau.set(i,j,color(0));
        }else if(blau == 1){
          bit1Blau.set(i,j,color(255));
        }
               
      }
    } 
    bit1Rot.save("data/Bit1VerteilungRot.png");
    bit1Gruen.save("data/Bit1VerteilungGruen.png");
    bit1Blau.save("data/Bit1VerteilungBlau.png");    
    
  //HBS-Modus  
    colorMode(HSB,256,256,256);
    bild = loadImage("data/bild.png");//Kontrolle der lowBit-Verteilung ursprünglich
    bit1Farbe=  loadImage("data/leer.png");
    bit1Saettigung = loadImage("data/leer.png");
    bit1Helligkeit = loadImage("data/leer.png");
    for (int j = 0; j < M; j++) {
      for (int i = 0; i < N; i++) { 
        farbe1 = bild.get(i,j);//Textfarbe
        helligkeit = int(brightness(farbe1)) & bitPosition; 
        saettigung = int(saturation(farbe1)) & bitPosition;
        farbwert = int(hue(farbe1)) & bitPosition;
        
        if( farbwert == 0){
          bit1Farbe.set(i,j,color(0));
        }else if(farbwert ==1){
          bit1Farbe.set(i,j,color(255));
        }
        
        if( saettigung == 0){
          bit1Saettigung.set(i,j,color(0));
        }else if(saettigung ==1){
          bit1Saettigung.set(i,j,color(255));
        }
        
        if( helligkeit == 0){
          bit1Helligkeit.set(i,j,color(0));
        }else if(helligkeit == 1){
          bit1Helligkeit.set(i,j,color(255));
        }
      }
    } 
    bit1Farbe.save("data/BitverteilungFarbe.png");
    bit1Saettigung.save("data/BitverteilungSaettigung.png");
    bit1Helligkeit.save("data/BitverteilungHelligkeit.png");
    bildAnzeigen = bit1Helligkeit;    
}
////////////////////////////////////////////////////////////////////
//Alle niederwertigsten Bits (blau oder Helligkeit) auf 1 setzten
//um Klartext dort zu verstecken. Nicht sonderlich sinnvoll!
void alleBlauBitsEins(){
 
    bildAnzeigen = bild;
    bild = loadImage("data/bild.png");
    for (int j = 0; j < M; j++) {
      for (int i = 0; i < N; i++) { 
        farbe1 = bild.get(i,j); 
        if(farbe1 % 2 == 0)   bild.set(i,j,farbe1+1);
      } 
    }
    
    bild.save("data/bildV.png");
    
}